from vcCommand import *

app = getApplication()
teach = getApplication().TeachContext

def SelectMode(args):
  if mode.Value == "Component":
    parentVector.IsVisible = True
    component.IsVisible = True
    setParentVector.IsVisible = True
    componentNode.IsVisible = False
    componentPath.IsVisible = False
  if mode.Value == "ComponentNode":
    parentVector.IsVisible = True
    componentNode.IsVisible = True
    setParentVector.IsVisible = True
    component.IsVisible = False
    componentPath.IsVisible = False
  if mode.Value == "ComponentPath":
    componentPath.IsVisible = True
    parentVector.IsVisible = False
    component.IsVisible = False
    componentNode.IsVisible = False
    setParentVector.IsVisible = False

def Attention(args):
  print "Parent(ComponentPath):"
  print "只有第一个值有效，请勿多选/Only the first value is valid, please do not select multiple options"
  
def SelectLimitation(args):
  if limitation.Value == True:
    errorRange.IsVisible = True
  if limitation.Value == False:
    errorRange.IsVisible = False

def OnStart():
  routine = teach.ActiveScope
  
  processStatement = routine.addStatement(VC_STATEMENT_PROCESS, teach.ActiveStatementIndex + 1, "rAttach")
  processStatement.Name = "Attach"+str(teach.ActiveStatementIndex + 1)
  
  name = processStatement.getProperty('Name')
  base = processStatement.getProperty('Base')
  tool = processStatement.getProperty('Tool')
  
  processStatement.createProperty(VC_STRING, 'Mode', VC_PROPERTY_STEP)
  processStatement.createProperty(VC_VECTOR, 'ParentVector')
  processStatement.createProperty(VC_STRING, 'Parent(Component)')
  processStatement.createProperty(VC_STRING, 'Parent(ComponentNode)')
  processStatement.createProperty('List<Ref<Behaviour>>', 'Parent(ComponentPath)')
  #processStatement.createProperty('Ref<Behaviour>', 'Parent(ComponentPath)')
  processStatement.createProperty(VC_BUTTON, 'SetParentVector')
  
  processStatement.createProperty(VC_VECTOR, 'ChildVector')
  processStatement.createProperty(VC_STRING, 'Child')
  processStatement.createProperty(VC_BUTTON, 'SetChildVector')
  
  processStatement.createProperty(VC_BOOLEAN, 'Limitation')
  processStatement.createProperty(VC_REAL, 'ErrorRange')
  
  global mode, parentVector, component, componentNode, componentPath, setParentVector, limitation, errorRange
  mode = processStatement.getProperty('Mode')
  parentVector = processStatement.getProperty('ParentVector')
  component = processStatement.getProperty('Parent(Component)')
  componentNode = processStatement.getProperty('Parent(ComponentNode)')
  componentPath = processStatement.getProperty('Parent(ComponentPath)')
  setParentVector = processStatement.getProperty('SetParentVector')
  limitation = processStatement.getProperty('Limitation')
  errorRange = processStatement.getProperty('ErrorRange')
  
  parentVector.IsVisible = False
  component.IsVisible = False
  componentNode.IsVisible = False
  componentPath.IsVisible = False
  setParentVector.IsVisible = False
  errorRange.IsVisible = False
  
  mode.StepValues = ["Component","ComponentNode","ComponentPath"]
  errorRange.Quantity = "Distance"
  errorRange.Value = 100
  mode.OnChanged = SelectMode
  limitation.OnChanged = SelectLimitation
  componentPath.OnChanged = Attention
  
  robot = teach.ActiveRobot 
  attachStatementScriptName = 'StatementScript_' + processStatement.Name
  attachStatementScript = robot.findBehaviour(attachStatementScriptName)
  if not attachStatementScript:
    attachStatementScript = robot.createBehaviour(VC_PYTHONPROCESSHANDLER, attachStatementScriptName)
  attachStatementScript.Script = '''
from vcPythonProcessHandler import *
import vcVector

app = getApplication()
snap = app.findCommand('interactiveSnap') 

def ParentPicked(arg):
  global mode, parentVector, parentName, parentNode
  if mode.Value == "Component":
    target = snap.TargetNode.Component  
    parentVector.Value = target.WorldPositionMatrix.P
    parentName.Value = target.Name
  if mode.Value == "ComponentNode":
    parentName.Value = snap.TargetNode.Component.Name
    target = snap.TargetNode 
    parentVector.Value = target.WorldPositionMatrix.P
    parentNode.Value = target.Name

def ChildPicked(arg):
  global childVector, childName
  target = snap.TargetNode.Component  
  childVector.Value = target.WorldPositionMatrix.P
  childName.Value = target.Name
  
def OnPickComponent(arg):
  snap.clear() 
  if 'Parent' in arg.Name:
    snap.OnTargetSet = ParentPicked   
  elif 'Child' in arg.Name:
    snap.OnTargetSet = ChildPicked   
  snap.execute()

def hideOthers(statement):
  name = statement.getProperty('Name')
  name.IsVisible = False
  base = statement.getProperty('Base')
  base.IsVisible = False
  tool = statement.getProperty('Tool')
  tool.IsVisible = False

def setEvents(statement):
  global mode, parentVector, parentName, childVector, childName, parentNode, componentPath, limitation, errorRange
  
  mode = statement.getProperty('Mode')
  parentVector = statement.getProperty('ParentVector')
  parentName = statement.getProperty('Parent(Component)')
  childVector = statement.getProperty('ChildVector')
  childName = statement.getProperty('Child')
  parentNode = statement.getProperty('Parent(ComponentNode)')
  componentPath = statement.getProperty('Parent(ComponentPath)')
  limitation = statement.getProperty('Limitation')
  errorRange = statement.getProperty('ErrorRange')
  
  global setParentVector, setChildVector
  setParentVector = statement.getProperty('SetParentVector')
  if setParentVector:
    if not setParentVector.OnChanged:
      setParentVector.OnChanged = OnPickComponent  
  setChildVector = statement.getProperty('SetChildVector')
  if setChildVector:
    if not setChildVector.OnChanged:
      setChildVector.OnChanged = OnPickComponent 

def OnStatementAdd(statement):
  # Hide others
  hideOthers(statement)
  
  # Set events
  setEvents(statement)

def OnStatementModified(statement):
  # Hide others
  hideOthers(statement)
  
  # Set events
  setEvents(statement)
  
def OnStatementExecute(executor, statement):  
  # Hide others
  hideOthers(statement)
  
  # Set events
  setEvents(statement)
  
  parent = None
  child = None
  
  if mode.Value == "Component":
    if parentName.Value != None and childName.Value != None:
      for part in app.Components:
        if limitation.Value == True:
          if part.Name == parentName.Value and (part.WorldPositionMatrix.P - parentVector.Value).length() < errorRange.Value:
            parent = part
          if part.Name == childName.Value and (part.WorldPositionMatrix.P - childVector.Value).length() < errorRange.Value:
            child = part
        if limitation.Value == False:
          if part.Name == parentName.Value:
            parent = part
          if part.Name == childName.Value:
            child = part         
      matrix = parent.InverseWorldPositionMatrix * child.WorldPositionMatrix
      parent.attach(child)
      child.PositionMatrix = matrix
  if mode.Value == "ComponentNode":
    if parentNode.Value != None and childName.Value != None:
      for part in app.Components:
        if limitation.Value == True:
          if part.Name == parentName.Value and (part.findNode(parentNode.Value).WorldPositionMatrix.P - parentVector.Value).length() < errorRange.Value:
            node = part.findNode(parentNode.Value)
          if part.Name == childName.Value and (part.WorldPositionMatrix.P - childVector.Value).length() < errorRange.Value:
            child = part
        if limitation.Value == False:
          if part.Name == parentName.Value:
            node = part.findNode(parentNode.Value)
          if part.Name == childName.Value:
            child = part      
      matrix = node.InverseWorldPositionMatrix * child.WorldPositionMatrix
      node.attach(child)
      child.PositionMatrix = matrix
  if mode.Value == "ComponentPath":
    if componentPath.Value[0] != None and childName.Value != None:
      for part in app.Components:
        if limitation.Value == True:
          if part.Name == componentPath.Value[0].Component.Name:
            path = part.findBehaviour(componentPath.Value[0].Name)
          if part.Name == childName.Value and (part.WorldPositionMatrix.P - childVector.Value).length() < errorRange.Value:
            child = part
        if limitation.Value == False:
          if part.Name == componentPath.Value[0].Component.Name:
            path = part.findBehaviour(componentPath.Value[0].Name)
          if part.Name == childName.Value:
            child = part
      path.grab(child)
  return



'''
  processStatement.Process = attachStatementScript
  app.SelectionManager.setSelection(processStatement)
